unit unEricThread;
interface
uses
  SysUtils, Classes, SyncObjs, System.Threading;

  procedure StrToStrings(S, Sep: string; const List: TStringList; const AllowEmptyString: Boolean=true; const NeedTrim: Boolean=false); overload;

type
  TEricThread = class(TObject)
  private
    FID:Integer;
    FFileName: String;
//    BufferMain:TStringBuilder;
//    BufferBad:TStringBuilder;
//    BufferIgnore:TStringBuilder;
  private
    procedure SyncMyWrite(aContent:String);
    procedure SyncMyWriteWarning(aContent:String);
//    procedure SyncBufferFWriteOut(aContent:String) overload;
//    procedure SyncBufferFWriteBad(aContent:String) overload;
//    procedure SyncBufferFWriteIgnore(aContent:String) overload;
  public
    FCount:Integer;
  public
    constructor Create(aID:Integer;AFileName: String);
    destructor  Destroy;override;
    procedure Execute;
  end;

implementation

uses
unEricAnalysis;

procedure StrToStrings(S, Sep: String; const List: TStringList; const AllowEmptyString: Boolean; const NeedTrim: Boolean); overload;
var
  I, L: Integer;
  Left: string;
begin
  Assert(List <> nil);
  List.BeginUpdate;
  try
    List.Clear;
    L := Length(Sep);
    I := Pos(Sep, S);
    while I > 0 do
    begin
      Left := Copy(S,1, I - 1);
      if (Left <> '') or AllowEmptyString then
      begin
        if NeedTrim then
          List.Add(Trim(Left))
        else
          List.Add(Left);
      end;
      Delete(S, 1, I + L - 1);
      I := Pos(Sep, S);
    end;
    if (S <> '') or AllowEmptyString then
        if NeedTrim then
          List.Add(Trim(S))
        else
          List.Add(S);
  finally
    List.EndUpdate;
  end;
end;

//const
//  FileBufferSize=48*1024;

constructor TEricThread.Create(aID:Integer;AFileName: String);
begin
  //FID:=0;//Single Threading Test
  FID:=aID;
  FFileName := AFileName;
//  BufferMain:=TStringBuilder.Create(FileBufferSize,2*FileBufferSize);
//  BufferBad:=TStringBuilder.Create(FileBufferSize,2*FileBufferSize);
//  BufferIgnore:=TStringBuilder.Create(FileBufferSize,2*FileBufferSize);
end;
destructor TEricThread.Destroy;
begin
//  FreeAndNil(BufferMain);
//  FreeAndNil(BufferBad);
//  FreeAndNil(BufferIgnore);
  inherited;
end;

procedure TEricThread.SyncMyWrite(aContent:String);
begin
  CSConsole.Acquire;
  WriteLn(aContent);
  CSConsole.Release;
end;
procedure TEricThread.SyncMyWriteWarning(aContent:String);
begin
  CSConsole.Acquire;
  WriteLn(aContent);
  CSConsole.Release;
end;

//procedure TEricThread.SyncBufferFWriteOut(aContent:String) overload;
//begin
//  FFLockOut.Acquire;
//  Write(oFileSubs,aContent);
//  FFLockOut.Release;
//end;
//procedure TEricThread.SyncBufferFWriteBad(aContent:String) overload;
//begin
//  FFLockBad.Acquire;
//  Write(oFileBad,aContent);
//  FFLockBad.Release;
//end;
//procedure TEricThread.SyncBufferFWriteIgnore(aContent:String) overload;
//begin
//  FFLockIgnore.Acquire;
//  Write(oFileIgn,aContent);
//  FFLockIgnore.Release;
//end;

procedure TEricThread.Execute;
var
  Afile:TextFile;
  aIgnCount,aBadCount,aAlarmCount:Integer;
  Aline:AnsiString;
  aValueList:TStringList;
begin
    Ftasks[FID] :=
    TTask.Create (procedure
    begin
      try
        SyncMyWrite('#'+IntToStr(TTask.CurrentTask.Id)+':ʼ'+ExtractFileName(FFileName)+'...');
        //charZero:=#0;
        aValueList:=TStringList.Create;
        AssignFile(Afile,FFileName);
        Reset(Afile);
        FCount:=0;

//        BufferMain.Clear;
//        BufferBad.Clear;
//        BufferIgnore.Clear;
        aIgnCount:=0;
        aBadCount:=0;
        aAlarmCount:=0;
        while not EOF(Afile) do
        begin
            Readln(Afile,Aline);
            Inc(FCount);
            try
              //䣬ȥ
              StrToStrings(String(Aline),#09,aValueList);
            except
              on e: exception do
              begin
                SyncMyWriteWarning('#'+IntToStr(TTask.CurrentTask.Id)+':'+e.Message+':'+String(Aline));
                Inc(aAlarmCount);
              end;
            end;

//          if aAlarmCount>=50 then
//          begin
//            SyncMyWriteWarning('#'+IntToStr(TTask.CurrentTask.Id)+':̫ľ棡');
//            exit;
//          end;
        end;

//        if BufferBad.Length>0 then
//        begin
//          SyncBufferFWriteBad(BufferBad.ToString);
//        end;
//        if BufferIgnore.Length>0 then
//        begin
//          SyncBufferFWriteIgnore(BufferIgnore.ToString);
//        end;
//        if BufferMain.Length>0 then
//        begin
//          SyncBufferFWriteOut(BufferMain.ToString);
//        end;

        SyncMyWrite('#'+IntToStr(TTask.CurrentTask.Id)+':'+IntToStr(FCount)+'Ч¼'+IntToStr(aBadCount)+'¼'+IntToStr(aIgnCount)+'Լ¼.');
        CloseFile(Afile);
        FreeAndNil(aValueList);
      except
        on e: exception do
        begin
          FCount:=-1;
          SyncMyWriteWarning('#'+IntToStr(TTask.CurrentTask.Id)+':'+e.Message);
        end;
      end;
    end);
    Ftasks[FID].Start;
end;
end.
