unit unEricAnalysis;
interface
uses
		Classes,SysUtils,Math;
var
    FParseItemList:TStringList;

procedure StrToStrings(S, Sep: string; const List: TStringList; const AllowEmptyString: Boolean=true; const NeedTrim: Boolean=false); overload;

//    oFileSubs:TextFile;
//    oBufSubs: array[1..16*1024] of AnsiChar;
//    oFileBad:TextFile;
//    oBufBad: array[1..16*1024] of AnsiChar;
//    oFileIgn:TextFile;
//    oBufIgn: array[1..16*1024] of AnsiChar;

//    CSConsole:TCriticalSection;
//    FFLockBad: TCriticalSection;
//    FFLockIgnore: TCriticalSection;
//    FFLockOut: TCriticalSection;
type
    TParseAna   =   class
    private
      ParseCfg:TStringList;
      oCountMain:Integer;
      fWorkPath:string;
      fInPath:string;
      ifDataDate:Boolean;

    public
      constructor Create(InPath:string;WorkPath:string);
      destructor  Destroy;override;
      procedure   Execute();
end;

implementation

procedure StrToStrings(S, Sep: String; const List: TStringList; const AllowEmptyString: Boolean; const NeedTrim: Boolean); overload;
var
  I, L: Integer;
  Left: string;
begin
  Assert(List <> nil);
  List.BeginUpdate;
  try
    List.Clear;
    L := Length(Sep);
    I := Pos(Sep, S);
    while I > 0 do
    begin
      Left := Copy(S,1, I - 1);
      if (Left <> '') or AllowEmptyString then
      begin
        if NeedTrim then
          List.Add(Trim(Left))
        else
          List.Add(Left);
      end;
      Delete(S, 1, I + L - 1);
      I := Pos(Sep, S);
    end;
    if (S <> '') or AllowEmptyString then
        if NeedTrim then
          List.Add(Trim(S))
        else
          List.Add(S);
  finally
    List.EndUpdate;
  end;
end;

constructor TParseAna.Create(InPath:string;WorkPath:string);
begin
//    CSConsole:=TCriticalSection.Create;
//    FFLockBad:=TCriticalSection.Create;
//    FFLockIgnore:=TCriticalSection.Create;
//    FFLockOut:=TCriticalSection.Create;
    fInPath:=InPath;
    //TheQueue:=TThreadedQueue<String>.Create(655350,INFINITE,1);
    fWorkPath:=WorkPath;
    ifDataDate:=false;
end;

destructor TParseAna.Destroy;
begin
  inherited;
//  CSConsole.Free;
//  FFLockBad.Free;
//  FFLockIgnore.Free;
//  FFLockOut.Free;
end;

procedure TParseAna.Execute;
var
  ASerch:TSearchRec;
  i,FCount:Integer;
  Afile:TextFile;
  aIgnCount,aBadCount,aAlarmCount:Integer;
  Aline:AnsiString;
  aValueList:TStringList;
begin
  oCountMain:=0;

  //FThreadList:=TObjectList<TEricThread>.Create(true);
  FParseItemList:=TStringList.Create;

//  AssignFile(oFileSubs,IncludeTrailingPathDelimiter(fWorkPath)+'subs.txt');
//  Rewrite(oFileSubs);
//  SetTextBuf(oFileSubs,oBufSubs);
//
//  AssignFile(oFileBad,IncludeTrailingPathDelimiter(fWorkPath)+'DataBad.txt');
//  Rewrite(oFileBad);
//  SetTextBuf(oFileBad,oBufBad);
//
//  AssignFile(oFileIgn,IncludeTrailingPathDelimiter(fWorkPath)+'DataIgnored.txt');
//  Rewrite(oFileIgn);
//  SetTextBuf(oFileIgn,oBufIgn);

  ParseCfg:=TStringlist.Create;
  if FindFirst(fInPath+'*.*', faReadOnly + faHidden, ASerch) = 0 then
  begin
    repeat
      FParseItemList.Add(fInPath+ASerch.Name);
    until FindNext(ASerch) <> 0;
    FindClose(ASerch);
  end;

  for i := 0 to FParseItemList.Count-1 do
  begin
        WriteLn('#'+IntToStr(i)+':ʼ'+ExtractFileName(FParseItemList[i])+'...');
        //charZero:=#0;
        aValueList:=TStringList.Create;
        AssignFile(Afile,FParseItemList[i]);
        Reset(Afile);
        FCount:=0;

//        BufferMain.Clear;
//        BufferBad.Clear;
//        BufferIgnore.Clear;
        aIgnCount:=0;
        aBadCount:=0;
        aAlarmCount:=0;
        while not EOF(Afile) do
        begin
            Readln(Afile,Aline);
            Inc(FCount);
            try
              //䣬ȥ
              StrToStrings(String(Aline),#09,aValueList);
            except
              on e: exception do
              begin
                WriteLn('#'+IntToStr(i)+':'+e.Message+':'+String(Aline));
                Inc(aAlarmCount);
              end;
            end;

//          if aAlarmCount>=50 then
//          begin
//            WriteLn('#'+IntToStr(i)+':̫ľ棡');
//            exit;
//          end;
        end;

//        if BufferBad.Length>0 then
//        begin
//          SyncBufferFWriteBad(BufferBad.ToString);
//        end;
//        if BufferIgnore.Length>0 then
//        begin
//          SyncBufferFWriteIgnore(BufferIgnore.ToString);
//        end;
//        if BufferMain.Length>0 then
//        begin
//          SyncBufferFWriteOut(BufferMain.ToString);
//        end;

        FreeAndNil(aValueList);

        WriteLn('#'+IntToStr(i)+':'+IntToStr(FCount)+'Ч¼'+IntToStr(aBadCount)+'¼'+IntToStr(aIgnCount)+'Լ¼.');
        CloseFile(Afile);
        oCountMain:=oCountMain+FCount;
  end;

//  CloseFile(oFileIgn);
//  CloseFile(oFileBad);
//  CloseFile(oFileSubs);

  ParseCfg.Add('subs='+IntToStr(oCountMain));
  ParseCfg.SaveToFile(IncludeTrailingPathDelimiter(fWorkPath)+'Parse.Cfg',TEncoding.GetEncoding('GBK'));
  WriteLn('SUBS'+IntToStr(oCountMain)+'');
  WriteLn('ɹ');
  FreeAndNil(ParseCfg);
  FreeAndNil(FParseItemList);
end;
end.
