unit unEricAnalysis;
{$mode objfpc}{$H+}
interface
uses
{$IFDEF UNIX}
cthreads,
{$ENDIF}
Classes,SysUtils,
SyncObjs,Math,
unEricThread;
var
    aThread:TEricThread;
    FThreadList:TList;
    FParseItemList:TStringList;

    //oFileSubs:TextFile;
    //oBufSubs: array[1..16*1024] of AnsiChar;
    //oFileBad:TextFile;
    //oBufBad: array[1..16*1024] of AnsiChar;
    //oFileIgn:TextFile;
    //oBufIgn: array[1..16*1024] of AnsiChar;

    CSConsole:TCriticalSection;
    //FFLockBad: TCriticalSection;
    //FFLockIgnore: TCriticalSection;
    //FFLockOut: TCriticalSection;
type
    THWanalysis   =   class
    private
      ParseCfg:TStringList;
      oCountMain:Integer;
      fWorkPath:string;
      fInPath:string;
      //ifDataDate:Boolean;
      MaxThreadCount:Integer;
    public
      constructor Create(InPath:string;WorkPath:string);
      destructor  Destroy;override;
      procedure   Execute();
end;
implementation

const
  //FieldLengthMax=3000;
  MaxCPUCore=32;
  MinCPUCore=4;

constructor THWanalysis.Create(InPath:string;WorkPath:string);
begin
    CSConsole:=TCriticalSection.Create;
    //FFLockBad:=TCriticalSection.Create;
    //FFLockIgnore:=TCriticalSection.Create;
    //FFLockOut:=TCriticalSection.Create;
    //TheQueue:=TThreadedQueue<String>.Create(655350,INFINITE,1);
    fWorkPath:=WorkPath;
    fInPath:=InPath;
    //ifDataDate:=false;
end;

destructor THWanalysis.Destroy;
begin
  inherited;
  CSConsole.Free;
  //FFLockBad.Free;
  //FFLockIgnore.Free;
  //FFLockOut.Free;
end;

procedure THWanalysis.Execute;
var
  ASerch:TSearchRec;
  aPath:String;
  //ADataDate:TDateTime;
  //i:Integer;

  procedure CheckSubFinish();
  var
    j:Integer;
    aID,aRet:Cardinal;
    aThread:TEricThread;
  begin
    for j:=FThreadList.Count-1 downto 0 do
    begin
      aThread:=TEricThread(FThreadList.Items[j]);
      if aThread.Finished then
      begin
        aID:=aThread.FNum;
        aRet:=aThread.WaitFor;
        oCountMain:=oCountMain+aThread.FCount;
        FThreadList.Delete(j);
        if aRet<=0 then
        begin
          raise Exception.Create('T'+IntToStr(aID)+':运行结果错误!');
        end;
      end;
    end;
    Sleep(20);
  end;

begin
  //ADataDate:=0;
  oCountMain:=0;
  MaxThreadCount:=Min(Max((TThread.ProcessorCount div 2),MinCPUCore),MaxCPUCore);
  //MyWrite('MaxThreadCount='+IntToStr(MaxThreadCount));

  FThreadList:=TList.Create();
  FParseItemList:=TStringList.Create;

  //OpenF(oFileSubs,IncludeTrailingPathDelimiter(fWorkPath)+'subs.txt');
  //SetTextBuf(oFileSubs,oBufSubs);
  //
  //OpenF(oFileBad,IncludeTrailingPathDelimiter(fWorkPath)+'DataBad.txt');
  //SetTextBuf(oFileBad,oBufBad);
  //
  //OpenF(oFileIgn,IncludeTrailingPathDelimiter(fWorkPath)+'DataIgnored.txt');
  //SetTextBuf(oFileIgn,oBufIgn);

  ParseCfg:=TStringlist.Create;

	aPath:=IncludeTrailingPathDelimiter(fInPath);
    if FindFirst(aPath+'*.*', faReadOnly, ASerch) = 0 then
    begin
      repeat
        //if (not ifDataDate) and GetDateTime(ASerch.Name,ADataDate,false) then
        //begin
        //  ifDataDate:=True;
        //  ParseCfg.Add('DataDate='+FloatToStr(ADataDate));
        //end;
        FParseItemList.Add(aPath+ASerch.Name);
      until FindNext(ASerch) <> 0;
      FindClose(ASerch);
    end;

  //MyWrite('found files='+IntToStr(FParseItemList.Count));

  while FParseItemList.Count>0 do
  begin
    while FThreadList.Count>=MaxThreadCount do
    begin
      CheckSubFinish();
    end;
    FThreadList.Add(TEricThread.Create(FParseItemList.Count,FParseItemList[0]));
    FParseItemList.Delete(0);
  end;

  while FThreadList.Count>0 do
  begin
    CheckSubFinish();
  end;

  //CloseFile(oFileIgn);
  //CloseFile(oFileBad);
  //CloseFile(oFileSubs);

  ParseCfg.Add('subs='+IntToStr(oCountMain));
  ParseCfg.SaveToFile(IncludeTrailingPathDelimiter(fWorkPath)+'Parse.Cfg',TEncoding.GetEncoding('GBK'));
  MyWrite('解析SUBS表【'+IntToStr(oCountMain)+'】条');
  FreeAndNil(ParseCfg);
  FreeAndNil(FParseItemList);
  FreeAndNil(FThreadList);
end;
end.
