unit unEricThread;

{$mode objfpc}{$H+}

interface

uses
  SysUtils, Classes, SyncObjs;

procedure MyWrite(aMsg:String);
procedure StrToStrings(S, Sep: string; const List: TStringList; const AllowEmptyString: Boolean=true; const NeedTrim: Boolean=false); overload;

type
 // TEricPCC=record
 //   mscId:String;//  内部序列号：电话号码
 //   GrpId:String;//  签约
 //   StartD:String;//  生效日期
 //   EndD:String;//  失效日期
	//end;

  TEricThread = class(TThread)
  private
    FFileName: String;
    //BufferMain:String;
    //BufferBad:AnsiString;
    //BufferIgnore:AnsiString;
  private
    procedure SyncMyWrite(aContent:String);
    procedure SyncMyWriteWarning(aContent:String);
    //procedure SyncBufferFWriteOut(aContent:String) overload;
    //procedure SyncBufferFWriteBad(aContent:AnsiString) overload;
    //procedure SyncBufferFWriteIgnore(aContent:AnsiString) overload;
  public
    FNum: Integer;
    FCount:Integer;
  public
    constructor Create(i:Integer;AFileName: String);
    procedure Execute; override;
  end;

implementation
uses
unEricAnalysis;

//const
//  FileBufferSize=31*1024;

procedure MyWrite(aMsg:String);
begin
  WriteLn(UTF8ToAnsi(aMsg));
end;

procedure StrToStrings(S, Sep: String; const List: TStringList; const AllowEmptyString: Boolean; const NeedTrim: Boolean); overload;
var
  I, L: Integer;
  Left: string;
begin
  Assert(List <> nil);
  List.BeginUpdate;
  try
    List.Clear;
    L := Length(Sep);
    I := Pos(Sep, S);
    while I > 0 do
    begin
      Left := Copy(S,1, I - 1);
      if (Left <> '') or AllowEmptyString then
      begin
        if NeedTrim then
          List.Add(Trim(Left))
        else
          List.Add(Left);
      end;
      Delete(S, 1, I + L - 1);
      I := Pos(Sep, S);
    end;
    if (S <> '') or AllowEmptyString then
        if NeedTrim then
          List.Add(Trim(S))
        else
          List.Add(S);
  finally
    List.EndUpdate;
  end;
end;

constructor TEricThread.Create(i:Integer;AFileName: String);
begin
  FNum:=i;
  FFileName := AFileName;
  ReturnValue:=0;
  inherited Create(False);
end;

procedure TEricThread.SyncMyWrite(aContent:String);
begin
  CSConsole.Acquire;
  MyWrite(aContent);
  CSConsole.Release;
end;

procedure TEricThread.SyncMyWriteWarning(aContent:String);
begin
  CSConsole.Acquire;
  MyWrite(aContent);
  CSConsole.Release;
end;

//procedure TEricThread.SyncBufferFWriteOut(aContent:String) overload;
//begin
//  FFLockOut.Acquire;
//  Write(oFileSubs,aContent);
//  FFLockOut.Release;
//end;
//
//procedure TEricThread.SyncBufferFWriteBad(aContent:AnsiString) overload;
//begin
//  FFLockBad.Acquire;
//  Write(oFileBad,aContent);
//  FFLockBad.Release;
//end;
//
//procedure TEricThread.SyncBufferFWriteIgnore(aContent:AnsiString) overload;
//begin
//  FFLockIgnore.Acquire;
//  Write(oFileIgn,aContent);
//  FFLockIgnore.Release;
//end;

procedure TEricThread.Execute;
var
  Afile:TextFile;
  //CMDSize:Integer;
  aIgnCount,aBadCount,aAlarmCount:Integer;
  Aline:AnsiString;
  aValueList:TStringList;
  //OneLog:TEricPCC;
begin
  try
    SyncMyWrite('#'+IntToStr(FNum)+':开始解析【'+ExtractFileName(FFileName)+'】...');
    aValueList:=TStringList.Create;
    AssignFile(Afile,FFileName);
    Reset(Afile);
    FCount:=0;
    //BufferMain:='';
    //BufferBad:='';
    //BufferIgnore:='';

    aIgnCount:=0;
    aBadCount:=0;
    aAlarmCount:=0;
    while not EOF(Afile) do
    begin
      try
        Readln(Afile,Aline);
        StrToStrings(String(Aline),#09,aValueList);
        Inc(FCount);

//          TheQueue.PushItem(OneLog.mscId+
//              #09+OneLog.GrpId+
//              #09+OneLog.StartD+
//              #09+OneLog.EndD+
//              #10);
      except
        on e: exception do
        begin
          SyncMyWriteWarning('#'+IntToStr(FNum)+':'+e.Message+':'+String(Aline));
          Inc(aAlarmCount);
        end;
      end;
      if aAlarmCount>=50 then
      begin
        SyncMyWriteWarning('#'+IntToStr(FNum)+':解析出现太多的警告!');
        exit;
      end;
		end;
    //if Length(BufferBad)>0 then
    //begin
    //  SyncBufferFWriteBad(BufferBad);
    //end;
    //if Length(BufferIgnore)>0 then
    //begin
    //  SyncBufferFWriteIgnore(BufferIgnore);
    //end;
    //if Length(BufferMain)>0 then
    //begin
    //  SyncBufferFWriteOut(BufferMain);
    //end;
    SyncMyWrite('#'+IntToStr(FNum)+':完成'+IntToStr(FCount)+'有效记录,'+IntToStr(aBadCount)+'错误记录,'+IntToStr(aIgnCount)+'忽略记录');
    //FreeAndNil(Afile);
    CloseFile(Afile);
    FreeAndNil(aValueList);
    ReturnValue:=1;
  except
    on e: exception do
    begin
      SyncMyWriteWarning('#'+IntToStr(FNum)+':'+e.Message);
    end;
  end;
end;

end.

