unit unEricAnalysis;
{$mode objfpc}{$H+}
interface
uses
Classes,SysUtils;
var
    //aThread:TEricThread;
    //FThreadList:TList;
    FParseItemList:TStringList;

    //oFileSubs:TextFile;
    //oBufSubs: array[1..16*1024] of AnsiChar;
    //oFileBad:TextFile;
    //oBufBad: array[1..16*1024] of AnsiChar;
    //oFileIgn:TextFile;
    //oBufIgn: array[1..16*1024] of AnsiChar;

    //CSConsole:TCriticalSection;
    //FFLockBad: TCriticalSection;
    //FFLockIgnore: TCriticalSection;
    //FFLockOut: TCriticalSection;
procedure MyWrite(aMsg:String);
procedure StrToStrings(S, Sep: string; const List: TStringList; const AllowEmptyString: Boolean=true; const NeedTrim: Boolean=false); overload;

type
    THWanalysis   =   class
    private
      ParseCfg:TStringList;
      oCountMain:Integer;
      fWorkPath:string;
      fInPath:string;
      //ifDataDate:Boolean;
      //MaxThreadCount:Integer;
    public
      constructor Create(InPath:string;WorkPath:string);
      destructor  Destroy;override;
      procedure   Execute();
end;
implementation

//const
  //FieldLengthMax=3000;
  //MaxCPUCore=32;
  //MinCPUCore=4;
procedure MyWrite(aMsg:String);
begin
  WriteLn(UTF8ToAnsi(aMsg));
end;

procedure StrToStrings(S, Sep: String; const List: TStringList; const AllowEmptyString: Boolean; const NeedTrim: Boolean); overload;
var
  I, L: Integer;
  Left: string;
begin
  Assert(List <> nil);
  List.BeginUpdate;
  try
    List.Clear;
    L := Length(Sep);
    I := Pos(Sep, S);
    while I > 0 do
    begin
      Left := Copy(S,1, I - 1);
      if (Left <> '') or AllowEmptyString then
      begin
        if NeedTrim then
          List.Add(Trim(Left))
        else
          List.Add(Left);
      end;
      Delete(S, 1, I + L - 1);
      I := Pos(Sep, S);
    end;
    if (S <> '') or AllowEmptyString then
        if NeedTrim then
          List.Add(Trim(S))
        else
          List.Add(S);
  finally
    List.EndUpdate;
  end;
end;

constructor THWanalysis.Create(InPath:string;WorkPath:string);
begin
    //CSConsole:=TCriticalSection.Create;
    //FFLockBad:=TCriticalSection.Create;
    //FFLockIgnore:=TCriticalSection.Create;
    //FFLockOut:=TCriticalSection.Create;
    //TheQueue:=TThreadedQueue<String>.Create(655350,INFINITE,1);
    fWorkPath:=WorkPath;
    fInPath:=InPath;
    //ifDataDate:=false;
end;

destructor THWanalysis.Destroy;
begin
  inherited;
  //CSConsole.Free;
  //FFLockBad.Free;
  //FFLockIgnore.Free;
  //FFLockOut.Free;
end;

procedure THWanalysis.Execute;
var
  ASerch:TSearchRec;
  i,FCount:Integer;
  Afile:TextFile;
  aIgnCount,aBadCount,aAlarmCount:Integer;
  Aline,aPath:AnsiString;
  aValueList:TStringList;
begin
  //ADataDate:=0;
  oCountMain:=0;
  //MaxThreadCount:=Min(Max((TThread.ProcessorCount div 2),MinCPUCore),MaxCPUCore);
  //MyWrite('MaxThreadCount='+IntToStr(MaxThreadCount));

  //FThreadList:=TList.Create();
  FParseItemList:=TStringList.Create;

  //OpenF(oFileSubs,IncludeTrailingPathDelimiter(fWorkPath)+'subs.txt');
  //SetTextBuf(oFileSubs,oBufSubs);
  //
  //OpenF(oFileBad,IncludeTrailingPathDelimiter(fWorkPath)+'DataBad.txt');
  //SetTextBuf(oFileBad,oBufBad);
  //
  //OpenF(oFileIgn,IncludeTrailingPathDelimiter(fWorkPath)+'DataIgnored.txt');
  //SetTextBuf(oFileIgn,oBufIgn);

  ParseCfg:=TStringlist.Create;

	aPath:=IncludeTrailingPathDelimiter(fInPath);
    if FindFirst(aPath+'*.*', faReadOnly, ASerch) = 0 then
    begin
      repeat
        //if (not ifDataDate) and GetDateTime(ASerch.Name,ADataDate,false) then
        //begin
        //  ifDataDate:=True;
        //  ParseCfg.Add('DataDate='+FloatToStr(ADataDate));
        //end;
        FParseItemList.Add(aPath+ASerch.Name);
      until FindNext(ASerch) <> 0;
      FindClose(ASerch);
    end;

  //MyWrite('found files='+IntToStr(FParseItemList.Count));

  for i := 0 to FParseItemList.Count-1 do
  begin
        MyWrite('#'+IntToStr(i)+':开始解析【'+ExtractFileName(FParseItemList[i])+'】...');
        //charZero:=#0;
        aValueList:=TStringList.Create;
        AssignFile(Afile,FParseItemList[i]);
        Reset(Afile);
        FCount:=0;

//        BufferMain.Clear;
//        BufferBad.Clear;
//        BufferIgnore.Clear;
        aIgnCount:=0;
        aBadCount:=0;
        aAlarmCount:=0;
        while not EOF(Afile) do
        begin
            Readln(Afile,Aline);
            Inc(FCount);
            try
              //当作处理过程留下这句，其它的已去掉。
              StrToStrings(String(Aline),#09,aValueList);
            except
              on e: exception do
              begin
                MyWrite('#'+IntToStr(i)+':'+e.Message+':'+String(Aline));
                Inc(aAlarmCount);
              end;
            end;

//          if aAlarmCount>=50 then
//          begin
//            MyWrite('#'+IntToStr(i)+':解析出现太多的警告！');
//            exit;
//          end;
        end;

//        if BufferBad.Length>0 then
//        begin
//          SyncBufferFWriteBad(BufferBad.ToString);
//        end;
//        if BufferIgnore.Length>0 then
//        begin
//          SyncBufferFWriteIgnore(BufferIgnore.ToString);
//        end;
//        if BufferMain.Length>0 then
//        begin
//          SyncBufferFWriteOut(BufferMain.ToString);
//        end;

        FreeAndNil(aValueList);

        MyWrite('#'+IntToStr(i)+':完成'+IntToStr(FCount)+'有效记录，'+IntToStr(aBadCount)+'错误记录，'+IntToStr(aIgnCount)+'忽略记录.');
        CloseFile(Afile);
        oCountMain:=oCountMain+FCount;
  end;

  //CloseFile(oFileIgn);
  //CloseFile(oFileBad);
  //CloseFile(oFileSubs);

  ParseCfg.Add('subs='+IntToStr(oCountMain));
  ParseCfg.SaveToFile(IncludeTrailingPathDelimiter(fWorkPath)+'Parse.Cfg',TEncoding.GetEncoding('GBK'));
  MyWrite('解析SUBS表【'+IntToStr(oCountMain)+'】条');
  FreeAndNil(ParseCfg);
  FreeAndNil(FParseItemList);
  //FreeAndNil(FThreadList);
end;
end.
